Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.jstacs.scoringFunctions
Class IndependentProductScoringFunction

    java.lang.Object
      de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
          de.jstacs.scoringFunctions.IndependentProductScoringFunction

All Implemented Interfaces:
  MotifDiscoverer, MutableMotifDiscoverer, NormalizableScoringFunction, ScoringFunction, Storable, Cloneable

    public class IndependentProductScoringFunction

extends AbstractNormalizableScoringFunction
implements MutableMotifDiscoverer

This class enables the user to model parts of a sequence independent of each other. For instance, the first part of the sequence is modeled by the first `NormalizableScoringFunction` and has the length of the first `NormalizableScoringFunction`, the second part starts directly after the first part, is modeled by the second `NormalizableScoringFunction` ... etc. It is also possible to use a `NormalizableScoringFunction` for more than one sequence part and in both orientations (if possible).
It is important to set the equivalent sample size (ESS) of each instance carefully, i.e., corresponding to the ESS of the parts.

Author:
  Jens Keilwagen

Nested Class Summary

Nested classes/interfaces inherited from interface de.jstacs.motifDiscovery.MotifDiscoverer
`MotifDiscoverer.KindOfProfile`

Field Summary

Fields inherited from class de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
`alphabets, length, r`

Fields inherited from interface de.jstacs.scoringFunctions.ScoringFunction
`UNKNOWN`

Constructor Summary
`IndependentProductScoringFunction(double ess, boolean plugIn, NormalizableScoringFunction... functions)` This constructor creates an instance of an `IndependentProductScoringFunction` from a given series of independent `NormalizableScoringFunction`s.
`IndependentProductScoringFunction(double ess, boolean plugIn, NormalizableScoringFunction[] functions, int[] length)` This constructor creates an instance of an `IndependentProductScoringFunction` from given series of independent `NormalizableScoringFunction`s and lengths.
`IndependentProductScoringFunction(double ess, boolean plugIn, NormalizableScoringFunction[] functions, int[] index, int[] length, boolean[] reverse)` This is the main constructor.
`IndependentProductScoringFunction(StringBuffer source)` This is the constructor for the interface `Storable`.

Method Summary
`void` | `addGradientOfLogPriorTerm(double[] grad, int start)` This method computes the gradient of `NormalizableScoringFunction.getLogPriorTerm()` for each parameter of this model.
`void` | `adjustHiddenParameters(int index, Sample[] data, double[][] weights)` Adjusts all hidden parameters including duration and mixture parameters according to the current values of the remaining parameters.
`IndependentProductScoringFunction` | `clone()` Creates a clone (deep copy) of the current `ScoringFunction` instance.
`int` | `extractSequenceParts(int scoringFunctionIndex, Sample[] data, Sample[] result)` This method extracts the corresponding `Sequence` parts for a specific `ScoringFunction`.
`double[][]` | `extractWeights(int number, double[][] weights)` This method creates the weights for `extractSequenceParts(int, Sample[], Sample[])`.
`protected void` | `fromXML(StringBuffer rep)` This method is called in the constructor for the `Storable` interface to create a scoring function from a `StringBuffer`.
`double[]` | `getCurrentParameterValues()` Returns a `double` array of dimension `ScoringFunction.getNumberOfParameters()` containing the current parameter values.
`double` | `getEss()` Returns the equivalent sample size (ess) of this model, i.e. the equivalent sample size for the class or component that is represented by this model.
`NormalizableScoringFunction[]` | `getFunctions()` This method returns a deep copy of the internally used `NormalizableScoringFunction`.
`int` | `getGlobalIndexOfMotifInComponent(int component, int motif)` Returns the global index of the `motif` used in `component`.
`int` | `getIndexOfMaximalComponentFor(Sequence sequence)` Returns the index of the component with the maximal score for the sequence `sequence`.
`int[]` | `getIndices()` This method returns a deep copy of the internally used indices of the `NormalizableScoringFunction` for the parts.
`String` | `getInstanceName()` Returns a short instance name.
`double` | `getLogNormalizationConstant()` Returns the logarithm of the sum of the scores over all sequences of the event space.
`double` | `getLogPartialNormalizationConstant(int parameterIndex)` Returns the logarithm of the partial normalization constant for the parameter with index `parameterIndex`.
`double` | `getLogPriorTerm()` This method computes a value that is proportional to ``NormalizableScoringFunction.getEss()` * `NormalizableScoringFunction.getLogNormalizationConstant()` + Math.log( prior )` where `prior` is the prior for the parameters of this model.
`double` | `getLogScore(Sequence seq, int start)` Returns the logarithmic score for the `Sequence` `seq` beginning at position `start` in the `Sequence`.
`double` | `getLogScoreAndPartialDerivation(Sequence seq, int start, IntList indices, DoubleList partialDer)` Returns the logarithmic score for a `Sequence` beginning at position `start` in the `Sequence` and fills lists with the indices and the partial derivations.
`int` | `getMotifLength(int motif)` This method returns the length of the motif with index `motif` .
`int` | `getNumberOfComponents()` Returns the number of components in this `MotifDiscoverer`.
`int` | `getNumberOfMotifs()` Returns the number of motifs for this `MotifDiscoverer`.
`int` | `getNumberOfMotifsInComponent(int component)` Returns the number of motifs that are used in the component `component` of this `MotifDiscoverer`.
`int` | `getNumberOfParameters()` Returns the number of parameters in this `ScoringFunction`.
`int` | `getNumberOfRecommendedStarts()` This method returns the number of recommended optimization starts.
`int[]` | `getPartialLengths()` This method returns a deep copy of the internally used partial lengths of the parts.
`double[]` | `getProfileOfScoresFor(int component, int motif, Sequence sequence, int startpos, MotifDiscoverer.KindOfProfile dist)` Returns the profile of the scores for component `component` and motif `motif` at all possible start positions of the motif in the sequence `sequence` beginning at `startpos`.
`boolean[]` | `getReverseSwitches()` This method returns a deep copy of the internally used switches for the parts whether to use the corresponding `NormalizableScoringFunction` forward or as reverse complement.
`int` | `getSizeOfEventSpaceForRandomVariablesOfParameter(int index)` Returns the size of the event space of the random variables that are affected by parameter no.
`double[]` | `getStrandProbabilitiesFor(int component, int motif, Sequence sequence, int startpos)` This method returns the probabilities of the strand orientations for a given subsequence if it is considered as site of the motif model in a specific component.
`void` | `initializeFunction(int index, boolean freeParams, Sample[] data, double[][] weights)` This method creates the underlying structure of the `ScoringFunction`.
`void` | `initializeFunctionRandomly(boolean freeParams)` This method initializes the `ScoringFunction` randomly.
`void` | `initializeMotif(int motifIndex, Sample data, double[] weights)` This method allows to initialize the model of a motif manually using a weighted sample.
`void` | `initializeMotifRandomly(int motif)` This method initializes the motif with index `motif` randomly using for instance `ScoringFunction.initializeFunctionRandomly(boolean)`.
`boolean` | `isInitialized()` This method can be used to determine whether the model is initialized.
`boolean` | `isNormalized()` This method indicates whether the implemented score is already normalized to 1 or not.
`boolean` | `modifyMotif(int motifIndex, int offsetLeft, int offsetRight)` Manually modifies the motif model with index `motifIndex`.
`void` | `setParameters(double[] params, int start)` This method sets the internal parameters to the values of `params` between `start` and `start + `ScoringFunction.getNumberOfParameters()` - 1`
`String` | `toString()`
`StringBuffer` | `toXML()` This method returns an XML representation as `StringBuffer` of an instance of the implementing class.

Methods inherited from class de.jstacs.scoringFunctions.AbstractNormalizableScoringFunction
`getAlphabetContainer, getInitialClassParam, getLength, getLogScore, getLogScoreAndPartialDerivation, getNumberOfStarts, isNormalized`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### IndependentProductScoringFunction

    public IndependentProductScoringFunction(double ess,
                                             boolean plugIn,
                                             NormalizableScoringFunction... functions)
                                      throws CloneNotSupportedException,
                                             IllegalArgumentException,
                                             WrongAlphabetException

  This constructor creates an instance of an `IndependentProductScoringFunction` from a given series of independent `NormalizableScoringFunction`s. The length that is modeled by each component is determined by `ScoringFunction.getLength()`. So the length should not be 0.

  Parameters:
    `ess` - the equivalent sample size
    `plugIn` - whether to use plugIn parameters for the parts, otherwise the last parameters are used for parts that are instance of `HomogeneousScoringFunction`
    `functions` - the components, i.e. the given series of independent `NormalizableScoringFunction`s
  Throws:
    `CloneNotSupportedException` - if at least one element of `functions` could not be cloned
    `IllegalArgumentException` - if at least one component has length 0 or if the equivalent sample size (ess) is smaller than zero (0)
    `WrongAlphabetException` - if the user tries to use an alphabet for a reverse complement that can not be used for a reverse complement.
  See Also:
    `IndependentProductScoringFunction(double, boolean, NormalizableScoringFunction[], int[])`

### IndependentProductScoringFunction

    public IndependentProductScoringFunction(double ess,
                                             boolean plugIn,
                                             NormalizableScoringFunction[] functions,
                                             int[] length)
                                      throws CloneNotSupportedException,
                                             IllegalArgumentException,
                                             WrongAlphabetException

  This constructor creates an instance of an `IndependentProductScoringFunction` from given series of independent `NormalizableScoringFunction`s and lengths.

  Parameters:
    `ess` - the equivalent sample size
    `plugIn` - whether to use plugIn parameters for the parts, otherwise the last parameters are used for parts that are instance of `HomogeneousScoringFunction`
    `functions` - the components, i.e. the given series of independent `NormalizableScoringFunction`s
    `length` - the lengths, one for each component
  Throws:
    `CloneNotSupportedException` - if at least one component could not be cloned
    `IllegalArgumentException` - if the lengths and the components are not matching or if the equivalent sample size (ess) is smaller than zero (0)
    `WrongAlphabetException` - if the user tries to use an alphabet for a reverse complement that can not be used for a reverse complement.
  See Also:
    `IndependentProductScoringFunction(double, boolean, NormalizableScoringFunction[], int[], int[], boolean[])`

### IndependentProductScoringFunction

    public IndependentProductScoringFunction(double ess,
                                             boolean plugIn,
                                             NormalizableScoringFunction[] functions,
                                             int[] index,
                                             int[] length,
                                             boolean[] reverse)
                                      throws CloneNotSupportedException,
                                             IllegalArgumentException,
                                             WrongAlphabetException

  This is the main constructor.

  Parameters:
    `ess` - the equivalent sample size
    `plugIn` - whether to use plugIn parameters for the parts, otherwise the last parameters are used for parts that are instance of `HomogeneousScoringFunction`
    `functions` - the `NormalizableScoringFunction`
    `index` - the index of the `NormalizableScoringFunction` at each part
    `length` - the length of each part
    `reverse` - a switch whether to use it directly or the reverse complementary strand
  Throws:
    `CloneNotSupportedException` - if at least one component could not be cloned
    `IllegalArgumentException` - if the lengths and the components are not matching or if the equivalent sample size (ess) is smaller than zero (0)
    `WrongAlphabetException` - if the user tries to use an alphabet for a reverse complement that can not be used for a reverse complement.

### IndependentProductScoringFunction

    public IndependentProductScoringFunction(StringBuffer source)
                                      throws NonParsableException

  This is the constructor for the interface `Storable`. Creates a new `IndependentProductScoringFunction` out of a `StringBuffer` as returned by `toXML()`.

  Parameters:
    `source` - the XML representation as `StringBuffer`
  Throws:
    `NonParsableException` - if the XML representation could not be parsed

Method Detail

### clone

    public IndependentProductScoringFunction clone()
                                            throws CloneNotSupportedException

  Description copied from interface: `ScoringFunction`
  Creates a clone (deep copy) of the current `ScoringFunction` instance.

  Specified by:
    `clone` in interface `MotifDiscoverer`
  Specified by:
    `clone` in interface `ScoringFunction`
  Overrides:
    `clone` in class `AbstractNormalizableScoringFunction`
  Returns:
    the cloned instance of the current `ScoringFunction`
  Throws:
    `CloneNotSupportedException` - if something went wrong while cloning the `ScoringFunction`
  See Also:
    `Cloneable`

### getSizeOfEventSpaceForRandomVariablesOfParameter

    public int getSizeOfEventSpaceForRandomVariablesOfParameter(int index)

  Description copied from interface: `NormalizableScoringFunction`
  Returns the size of the event space of the random variables that are affected by parameter no. `index`, i.e. the product of the sizes of the alphabets at the position of each random variable affected by parameter `index`. For DNA alphabets this corresponds to 4 for a PWM, 16 for a WAM except position 0, ...

  Specified by:
    `getSizeOfEventSpaceForRandomVariablesOfParameter` in interface `NormalizableScoringFunction`
  Parameters:
    `index` - the index of the parameter
  Returns:
    the size of the event space

### getLogNormalizationConstant

    public double getLogNormalizationConstant()

  Description copied from interface: `NormalizableScoringFunction`
  Returns the logarithm of the sum of the scores over all sequences of the event space.

  Specified by:
    `getLogNormalizationConstant` in interface `NormalizableScoringFunction`
  Returns:
    the logarithm of the normalization constant Z

### getLogPartialNormalizationConstant

    public double getLogPartialNormalizationConstant(int parameterIndex)
                                              throws Exception

  Description copied from interface: `NormalizableScoringFunction`
  Returns the logarithm of the partial normalization constant for the parameter with index `parameterIndex`. This is the logarithm of the partial derivation of the normalization constant for the parameter with index `parameterIndex`,
  .

  Specified by:
    `getLogPartialNormalizationConstant` in interface `NormalizableScoringFunction`
  Parameters:
    `parameterIndex` - the index of the parameter
  Returns:
    the logarithm of the partial normalization constant
  Throws:
    `Exception` - if something went wrong with the normalization
  See Also:
    `NormalizableScoringFunction.getLogNormalizationConstant()`

### getEss

    public double getEss()

  Description copied from interface: `NormalizableScoringFunction`
  Returns the equivalent sample size (ess) of this model, i.e. the equivalent sample size for the class or component that is represented by this model.

  Specified by:
    `getEss` in interface `NormalizableScoringFunction`
  Returns:
    the equivalent sample size.

### initializeFunction

    public void initializeFunction(int index,
                                   boolean freeParams,
                                   Sample[] data,
                                   double[][] weights)
                            throws Exception

  Description copied from interface: `ScoringFunction`
  This method creates the underlying structure of the `ScoringFunction`.

  Specified by:
    `initializeFunction` in interface `ScoringFunction`
  Parameters:
    `index` - the index of the class the `ScoringFunction` models
    `freeParams` - indicates whether the (reduced) parameterization is used
    `data` - the samples
    `weights` - the weights of the sequences in the samples
  Throws:
    `Exception` - if something went wrong

### extractSequenceParts

    public int extractSequenceParts(int scoringFunctionIndex,
                                    Sample[] data,
                                    Sample[] result)
                             throws Exception

  This method extracts the corresponding `Sequence` parts for a specific `ScoringFunction`.

  Parameters:
    `scoringFunctionIndex` - the index of the `ScoringFunction`
    `data` - the original data
    `result` - an array for the resulting `Sample`s of `Sequence`s; has to have same length as `data`
  Returns:
    the number how often the `ScoringFunction` was used
  Throws:
    `Exception` - if the Sample can not be created

### extractWeights

    public double[][] extractWeights(int number,
                                     double[][] weights)

  This method creates the weights for `extractSequenceParts(int, Sample[], Sample[])`.

  Parameters:
    `number` - the number how often the weights should be copied after each other.
    `weights` - the original weights
  Returns:
    the new weights (might be `null`)
  See Also:
    `extractSequenceParts(int, Sample[], Sample[])`

### fromXML

    protected void fromXML(StringBuffer rep)
                    throws NonParsableException

  Description copied from class: `AbstractNormalizableScoringFunction`
  This method is called in the constructor for the `Storable` interface to create a scoring function from a `StringBuffer`.

  Specified by:
    `fromXML` in class `AbstractNormalizableScoringFunction`
  Parameters:
    `rep` - the XML representation as `StringBuffer`
  Throws:
    `NonParsableException` - if the `StringBuffer` could not be parsed
  See Also:
    `AbstractNormalizableScoringFunction.AbstractNormalizableScoringFunction(StringBuffer)`

### getInstanceName

    public String getInstanceName()

  Description copied from interface: `ScoringFunction`
  Returns a short instance name.

  Specified by:
    `getInstanceName` in interface `ScoringFunction`
  Returns:
    a short instance name

### getFunctions

    public NormalizableScoringFunction[] getFunctions()
                                               throws Exception

  This method returns a deep copy of the internally used `NormalizableScoringFunction`.

  Returns:
    a deep copy of the internally used `NormalizableScoringFunction`
  Throws:
    `Exception` - if at least one `NormalizableScoringFunction` could not be cloned
  See Also:
    `getIndices()`, `getPartialLengths()`, `getReverseSwitches()`

### getIndices

    public int[] getIndices()

  This method returns a deep copy of the internally used indices of the `NormalizableScoringFunction` for the parts.

  Returns:
    a deep copy of the internally used indices of the `NormalizableScoringFunction` for the parts
  See Also:
    `getFunctions()`, `getPartialLengths()`, `getReverseSwitches()`

### getPartialLengths

    public int[] getPartialLengths()

  This method returns a deep copy of the internally used partial lengths of the parts.

  Returns:
    a deep copy of the internally used partial lengths of the parts
  See Also:
    `getFunctions()`, `getIndices()`, `getReverseSwitches()`

### getReverseSwitches

    public boolean[] getReverseSwitches()

  This method returns a deep copy of the internally used switches for the parts whether to use the corresponding `NormalizableScoringFunction` forward or as reverse complement.

  Returns:
    a deep copy of the internally used switches for the parts whether to use the corresponding `NormalizableScoringFunction` forward or as reverse complement
  See Also:
    `getFunctions()`, `getIndices()`, `getPartialLengths()`

### getCurrentParameterValues

    public double[] getCurrentParameterValues()
                                       throws Exception

  Description copied from interface: `ScoringFunction`
  Returns a `double` array of dimension `ScoringFunction.getNumberOfParameters()` containing the current parameter values. If one likes to use these parameters to start an optimization it is highly recommended to invoke `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])` before. After an optimization this method can be used to get the current parameter values.

  Specified by:
    `getCurrentParameterValues` in interface `ScoringFunction`
  Returns:
    the current parameter values
  Throws:
    `Exception` - if no parameters exist (yet)

### getLogScore

    public double getLogScore(Sequence seq,
                              int start)

  Description copied from interface: `ScoringFunction`
  Returns the logarithmic score for the `Sequence` `seq` beginning at position `start` in the `Sequence`.

  Specified by:
    `getLogScore` in interface `ScoringFunction`
  Parameters:
    `seq` - the `Sequence`
    `start` - the start position in the `Sequence`
  Returns:
    the logarithmic score for the `Sequence`

### getLogScoreAndPartialDerivation

    public double getLogScoreAndPartialDerivation(Sequence seq,
                                                  int start,
                                                  IntList indices,
                                                  DoubleList partialDer)

  Description copied from interface: `ScoringFunction`
  Returns the logarithmic score for a `Sequence` beginning at position `start` in the `Sequence` and fills lists with the indices and the partial derivations.

  Specified by:
    `getLogScoreAndPartialDerivation` in interface `ScoringFunction`
  Parameters:
    `seq` - the `Sequence`
    `start` - the start position in the `Sequence`
    `indices` - an `IntList` of indices, after method invocation the list should contain the indices i where is not zero
    `partialDer` - a `DoubleList` of partial derivations, after method invocation the list should contain the corresponding that are not zero
  Returns:
    the logarithmic score for the `Sequence`

### getNumberOfParameters

    public int getNumberOfParameters()

  Description copied from interface: `ScoringFunction`
  Returns the number of parameters in this `ScoringFunction`. If the number of parameters is not known yet, the method returns `ScoringFunction.UNKNOWN`.

  Specified by:
    `getNumberOfParameters` in interface `ScoringFunction`
  Returns:
    the number of parameters in this `ScoringFunction`
  See Also:
    `ScoringFunction.UNKNOWN`

### getNumberOfRecommendedStarts

    public int getNumberOfRecommendedStarts()

  Description copied from interface: `ScoringFunction`
  This method returns the number of recommended optimization starts. The standard implementation returns 1.

  Specified by:
    `getNumberOfRecommendedStarts` in interface `ScoringFunction`
  Overrides:
    `getNumberOfRecommendedStarts` in class `AbstractNormalizableScoringFunction`
  Returns:
    the number of recommended optimization starts

### setParameters

    public void setParameters(double[] params,
                              int start)

  Description copied from interface: `ScoringFunction`
  This method sets the internal parameters to the values of `params` between `start` and `start + `ScoringFunction.getNumberOfParameters()` - 1`

  Specified by:
    `setParameters` in interface `ScoringFunction`
  Parameters:
    `params` - the new parameters
    `start` - the start index in `params`

### toXML

    public StringBuffer toXML()

  Description copied from interface: `Storable`
  This method returns an XML representation as `StringBuffer` of an instance of the implementing class.

  Specified by:
    `toXML` in interface `Storable`
  Returns:
    the XML representation

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getLogPriorTerm

    public double getLogPriorTerm()

  Description copied from interface: `NormalizableScoringFunction`
  This method computes a value that is proportional to

  ``NormalizableScoringFunction.getEss()` * `NormalizableScoringFunction.getLogNormalizationConstant()` + Math.log( prior )`

  where `prior` is the prior for the parameters of this model.

  Specified by:
    `getLogPriorTerm` in interface `NormalizableScoringFunction`
  Returns:
    a value that is proportional to ``NormalizableScoringFunction.getEss()` * `NormalizableScoringFunction.getLogNormalizationConstant()` + Math.log( prior ).`
  See Also:
    `NormalizableScoringFunction.getEss()`, `NormalizableScoringFunction.getLogNormalizationConstant()`

### addGradientOfLogPriorTerm

    public void addGradientOfLogPriorTerm(double[] grad,
                                          int start)
                                   throws Exception

  Description copied from interface: `NormalizableScoringFunction`
  This method computes the gradient of `NormalizableScoringFunction.getLogPriorTerm()` for each parameter of this model. The results are added to the array `grad` beginning at index `start`.

  Specified by:
    `addGradientOfLogPriorTerm` in interface `NormalizableScoringFunction`
  Parameters:
    `grad` - the array of gradients
    `start` - the start index in the `grad` array, where the partial derivations for the parameters of this models shall be entered
  Throws:
    `Exception` - if something went wrong with the computing of the gradients
  See Also:
    `NormalizableScoringFunction.getLogPriorTerm()`

### isInitialized

    public boolean isInitialized()

  Description copied from interface: `ScoringFunction`
  This method can be used to determine whether the model is initialized. If the model is not initialized you should invoke the method `ScoringFunction.initializeFunction(int, boolean, Sample[], double[][])`.

  Specified by:
    `isInitialized` in interface `ScoringFunction`
  Returns:
    `true` if the model is initialized, `false` otherwise

### initializeFunctionRandomly

    public void initializeFunctionRandomly(boolean freeParams)
                                    throws Exception

  Description copied from interface: `ScoringFunction`
  This method initializes the `ScoringFunction` randomly. It has to create the underlying structure of the `ScoringFunction`.

  Specified by:
    `initializeFunctionRandomly` in interface `ScoringFunction`
  Parameters:
    `freeParams` - indicates whether the (reduced) parameterization is used
  Throws:
    `Exception` - if something went wrong

### initializeMotif

    public void initializeMotif(int motifIndex,
                                Sample data,
                                double[] weights)
                         throws Exception

  Description copied from interface: `MutableMotifDiscoverer`
  This method allows to initialize the model of a motif manually using a weighted sample.

  Specified by:
    `initializeMotif` in interface `MutableMotifDiscoverer`
  Parameters:
    `motifIndex` - the index of the motif in the motif discoverer
    `data` - the sample of sequences
    `weights` - either `null` or an array of length `data.getNumberofElements()` with non-negative weights.
  Throws:
    `Exception` - if initialize was not possible

### initializeMotifRandomly

    public void initializeMotifRandomly(int motif)
                                 throws Exception

  Description copied from interface: `MutableMotifDiscoverer`
  This method initializes the motif with index `motif` randomly using for instance `ScoringFunction.initializeFunctionRandomly(boolean)`. Furthermore, if available, it also initializes the positional distribution.

  Specified by:
    `initializeMotifRandomly` in interface `MutableMotifDiscoverer`
  Parameters:
    `motif` - the index of the motif
  Throws:
    `Exception` - either if the index is wrong or if it is thrown by the method `ScoringFunction.initializeFunctionRandomly(boolean)`

### modifyMotif

    public boolean modifyMotif(int motifIndex,
                               int offsetLeft,
                               int offsetRight)
                        throws Exception

  Description copied from interface: `MutableMotifDiscoverer`
  Manually modifies the motif model with index `motifIndex`. The two offsets `offsetLeft` and `offsetRight` define how many positions the left or right border positions shall be moved. Negative numbers indicate moves to the left while positive numbers correspond to moves to the right. The distribution for sequences to the left and right side of the motif shall be computed internally.

  Specified by:
    `modifyMotif` in interface `MutableMotifDiscoverer`
  Parameters:
    `motifIndex` - the index of the motif in the motif discoverer
    `offsetLeft` - the offset on the left side
    `offsetRight` - the offset on the right side
  Returns:
    `true` if the motif model was modified otherwise `false`
  Throws:
    `Exception` - if some unexpected error occurred during the modification
  See Also:
    `MutableMotifDiscoverer.modifyMotif(int, int, int)`, `Mutable.modify(int, int)`

### getGlobalIndexOfMotifInComponent

    public int getGlobalIndexOfMotifInComponent(int component,
                                                int motif)

  Description copied from interface: `MotifDiscoverer`
  Returns the global index of the `motif` used in `component`. The index returned must be at least 0 and less than `MotifDiscoverer.getNumberOfMotifs()`.

  Specified by:
    `getGlobalIndexOfMotifInComponent` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component index
    `motif` - the motif index in the component
  Returns:
    the global index of the `motif`in `component```

### getIndexOfMaximalComponentFor

    public int getIndexOfMaximalComponentFor(Sequence sequence)
                                      throws Exception

  Description copied from interface: `MotifDiscoverer`
  Returns the index of the component with the maximal score for the sequence `sequence`.

  Specified by:
    `getIndexOfMaximalComponentFor` in interface `MotifDiscoverer`
  Parameters:
    `sequence` - the given sequence
  Returns:
    the index of the component with the maximal score for the given sequence
  Throws:
    `Exception` - if the index could not be computed for any reasons

### getMotifLength

    public int getMotifLength(int motif)

  Description copied from interface: `MotifDiscoverer`
  This method returns the length of the motif with index `motif` .

  Specified by:
    `getMotifLength` in interface `MotifDiscoverer`
  Parameters:
    `motif` - the index of the motif
  Returns:
    the length of the motif with index `motif`

### getNumberOfComponents

    public int getNumberOfComponents()

  Description copied from interface: `MotifDiscoverer`
  Returns the number of components in this `MotifDiscoverer`.

  Specified by:
    `getNumberOfComponents` in interface `MotifDiscoverer`
  Returns:
    the number of components

### getNumberOfMotifs

    public int getNumberOfMotifs()

  Description copied from interface: `MotifDiscoverer`
  Returns the number of motifs for this `MotifDiscoverer`.

  Specified by:
    `getNumberOfMotifs` in interface `MotifDiscoverer`
  Returns:
    the number of motifs

### getNumberOfMotifsInComponent

    public int getNumberOfMotifsInComponent(int component)

  Description copied from interface: `MotifDiscoverer`
  Returns the number of motifs that are used in the component `component` of this `MotifDiscoverer`.

  Specified by:
    `getNumberOfMotifsInComponent` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component of the `MotifDiscoverer`
  Returns:
    the number of motifs

### getProfileOfScoresFor

    public double[] getProfileOfScoresFor(int component,
                                          int motif,
                                          Sequence sequence,
                                          int startpos,
                                          MotifDiscoverer.KindOfProfile dist)
                                   throws Exception

  Description copied from interface: `MotifDiscoverer`
  Returns the profile of the scores for component `component` and motif `motif` at all possible start positions of the motif in the sequence `sequence` beginning at `startpos`. This array should be of length
  `sequence.length() - startpos - motifs[motif].length() + 1`.
  A high score should encode for a probable start position.

  Specified by:
    `getProfileOfScoresFor` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component index
    `motif` - the index of the motif in the component
    `sequence` - the given sequence
    `startpos` - the start position in the sequence
    `dist` - indicates the kind of profile
  Returns:
    the profile of scores
  Throws:
    `Exception` - if the score could not be computed for any reasons

### getStrandProbabilitiesFor

    public double[] getStrandProbabilitiesFor(int component,
                                              int motif,
                                              Sequence sequence,
                                              int startpos)
                                       throws Exception

  Description copied from interface: `MotifDiscoverer`
  This method returns the probabilities of the strand orientations for a given subsequence if it is considered as site of the motif model in a specific component.

  Specified by:
    `getStrandProbabilitiesFor` in interface `MotifDiscoverer`
  Parameters:
    `component` - the component index
    `motif` - the index of the motif in the component
    `sequence` - the given sequence
    `startpos` - the start position in the sequence
  Returns:
    the probabilities of the strand orientations
  Throws:
    `Exception` - if the strand could not be computed for any reasons

### isNormalized

    public boolean isNormalized()

  Description copied from interface: `NormalizableScoringFunction`
  This method indicates whether the implemented score is already normalized to 1 or not. The standard implementation returns `false`.

  Specified by:
    `isNormalized` in interface `NormalizableScoringFunction`
  Overrides:
    `isNormalized` in class `AbstractNormalizableScoringFunction`
  Returns:
    `true` if the implemented score is already normalized to 1, `false` otherwise

### adjustHiddenParameters

    public void adjustHiddenParameters(int index,
                                       Sample[] data,
                                       double[][] weights)
                                throws Exception

  Description copied from interface: `MutableMotifDiscoverer`
  Adjusts all hidden parameters including duration and mixture parameters according to the current values of the remaining parameters.

  Specified by:
    `adjustHiddenParameters` in interface `MutableMotifDiscoverer`
  Parameters:
    `index` - the index of the class of this `MutableMotifDiscoverer`
    `data` - the array of data for all classes
    `weights` - the weights for all sequences in data
  Throws:
    `Exception` - thrown if the hidden parameters could not be adjusted

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD